
;- Definitions

; Sign results:
Enumeration
	#Z_Negative = -1
	#Z_Unsign   =  0
	#Z_Positive =  1
EndEnumeration

; Compare results:
Enumeration
	#Z_Less     = -1
	#Z_Equal    =  0
	#Z_Greater  =  1
EndEnumeration

; Structure of an unlimited integer:
Structure Z
	Sign.i
	Type.i
	Location.i
	LastField.i
	Array Field.i(0)
EndStructure

;- Procedures

Declare Z_Init(*Create, *Expand)
Declare.d Z_Log(*Source.Z)
Declare Z_Simplify(*Use.Z)
Declare Z_Zero(*Use.Z)
Declare Z_One(*Use.Z, Sign.i=#Z_Positive)
Declare Z_Infinity(*Use.Z, Sign.i=#Z_Positive)
Declare Z_Error(*Use.Z)
Declare Z_Copy(*Use.Z, *Source.Z)
Declare Z_Set(*InOut.Z, Quad.q)
Declare.q Z_Get(*Source.Z)
Declare Z_Number(*Use.Z, String.s)
Declare Z_String_DLL(*Source.Z)
Declare Z_IsZero(*Source.Z)
Declare Z_IsQuad(*Source.Z)
Declare Z_Compare(*Source1.Z, *Source2.Z)
Declare Z_Sign(*Source.Z)
Declare Z_Add(*Use.Z, *Source.Z)
Declare Z_Subtract(*Use.Z, *Source.Z)
Declare Z_Multiply(*Use.Z, *Source.Z)
Declare Z_Divide(*Use.Z, *Source.Z, *Residual.Z=#Null)
Declare Z_Abs(*Use.Z)
Declare Z_Power(*Use.Z, *Source1.Z, *Source2.Z=#Null)
Declare Z_PowerModulo(*Use.Z, *Source1.Z, *Source2.Z)
Declare Z_Pochhammer(*Use.Z, Range.i)
Declare Z_Factorial(*Use.Z)
Declare Z_Modulo(*Use.Z, *Source.Z)
Declare Z_Random(*Use.Z, *Source.Z)
Declare Z_Shift(*Use.Z, Shift.i)
Declare Z_GreatestCommonDivisor(*Use.Z, *Source1.Z, *Source2.Z)
Declare Z_LeastCommonMultiple(*Use.Z, *Source1.Z, *Source2.Z)


CompilerIf SizeOf(Integer) = SizeOf(Long)
	CompilerIf SizeOf(Character) = SizeOf(Ascii)
		Import "UnlimitedIntegerArithmetic32.lib"
	CompilerElse
		Import "UnlimitedIntegerArithmetic32u.lib"
	CompilerEndIf
CompilerElse
	CompilerIf SizeOf(Character) = SizeOf(Ascii)
		Import "UnlimitedIntegerArithmetic64.lib"
	CompilerElse
		Import "UnlimitedIntegerArithmetic64u.lib"
	CompilerEndIf
CompilerEndIf
	Z_Init(*Create, *Expand)
	Z_Log.d(*Source.Z)
	Z_Simplify(*Use.Z)
	Z_Zero(*Use.Z)
	Z_One(*Use.Z, Sign.i=#Z_Positive)
	Z_Infinity(*Use.Z, Sign.i=#Z_Positive)
	Z_Error(*Use.Z)
	Z_Copy(*Use.Z, *Source.Z)
	Z_Set(*InOut.Z, Quad.q)
	Z_Get.q(*Source.Z)
	Z_Number(*Use.Z, String.s)
	Z_String_DLL(*Source.Z)
	Z_IsZero(*Source.Z)
	Z_IsQuad(*Source.Z)
	Z_Compare(*Source1.Z, *Source2.Z)
	Z_Sign(*Source.Z)
	Z_Add(*Use.Z, *Source.Z)
	Z_Subtract(*Use.Z, *Source.Z)
	Z_Multiply(*Use.Z, *Source.Z)
	Z_Divide(*Use.Z, *Source.Z, *Residual.Z=#Null)
	Z_Abs(*Use.Z)
	Z_Power(*Use.Z, *Source1.Z, *Source2.Z=#Null)
	Z_PowerModulo(*Use.Z, *Source1.Z, *Source2.Z)
	Z_Pochhammer(*Use.Z, Range.i)
	Z_Factorial(*Use.Z)
	Z_Modulo(*Use.Z, *Source.Z)
	Z_Random(*Use.Z, *Source.Z)
	Z_Shift(*Use.Z, Shift.i)
	Z_GreatestCommonDivisor(*Use.Z, *Source1.Z, *Source2.Z)
	Z_LeastCommonMultiple(*Use.Z, *Source1.Z, *Source2.Z)
EndImport



Procedure.i Z_Dim(*Use.Z, Size.i)
	Dim *Use\Field(Size)
EndProcedure

Procedure.i Z_ReDim(*Use.Z, Size.i)
	ReDim *Use\Field(Size)
EndProcedure

Macro Z_String(Source)
	PeekS(Z_String_DLL(Source))
EndMacro

Z_Init(@Z_Dim(), @Z_ReDim())

; IDE Options = PureBasic 5.22 LTS (Windows - x64)
; CursorPosition = 70
; FirstLine = 55
; Folding = --
; EnableXP
; Compiler = PureBasic 5.20 LTS (Windows - x86)
; EnableCompileCount = 26
; EnableBuildCount = 0